{ sent comments to den_ism@yahoo.com
  if you have an idea with this thing let me know !
  if you want to make this stuff into a component and just do it,
  so let me see ! }

unit LedakUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    PosXAkhir, PosYAkhir,
    MarginAtas, MarginKiri, ke,
    lebar, tinggi : integer;
    LeftTopDef, WiHiDef : TPoint;
    FullRgn, FullDasRgn : THandle;
    buka, tutup : boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 inc(ke);
 if ke > 7 then Application.Terminate;
 Height := height - tinggi;
 Width  := width - lebar;
 left   := left + MarginKiri;
 Top    := Top  + MarginAtas;
 FullRgn := CreateRectRgn(0, 0, Width, Height);
 FullDasRgn := CreateRectRgn(1, 1, Width-1, Height-1);
 CombineRgn( FullRgn, FullRgn, FullDasRgn, RGN_DIFF );
 SetWindowRgn(Handle, FullRgn, TRUE);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var pt : TPoint;
begin
 FullRgn := CreateRectRgn(0, 0, Width, Height);
 FullDasRgn := CreateRectRgn(1, 1, Width-1, Height-1);
 CombineRgn( FullRgn, FullRgn, FullDasRgn, RGN_DIFF );
 SetWindowRgn(Handle, FullRgn, TRUE);

 GetCursorPos(pt);       //
 PosXAkhir := pt.x;      // Last position mouse pointer
 PosYAkhir := pt.y;      //

 lebar  := width div 12;                   //
 tinggi := height div 12;                  //
 MarginAtas := (PosYAkhir-Top)  div 12;    //
 MarginKiri := (PosXAkhir-Left) div 12;    //

 ke := 0;
 tutup := true;
 ShowWindow(Application.handle,sw_hide); // hide flicker on taskbar and another
 timer1.Enabled := true;
 Application.Run;  // Make Application run again then terminate with timer1
end;

procedure TForm1.FormCreate(Sender: TObject);
var pt : TPoint;
begin
 GetCursorPos(pt);       //
 PosXAkhir := pt.x;      // Last position mouse pointer
 PosYAkhir := pt.y;      //

 LeftTopDef := Point(Left,Top);      // Default Position
 WiHiDef    := Point(width,height);  // Default Size

 width := 3;            //
 height := 3;           //  Set Form position
 left := PosXAkhir;     //
 top  := PosYAkhir;     //

 ke := 0;
 buka := true;
 tutup := false;

 FullRgn := CreateRectRgn(0, 0, Width, Height);        //
 FullDasRgn := CreateRectRgn(1, 1, Width-1, Height-1); // Hide Caption before Formshow
 CombineRgn( FullRgn, FullRgn, FullDasRgn, RGN_DIFF ); //
 SetWindowRgn(Handle, FullRgn, TRUE);                  //
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 inc(ke);
 if ke > 10 then
 begin
  left := LeftTopDef.x;
  top  := LEftTopDef.y;
  width := WiHiDef.x;
  height := WiHiDef.y;
  FullRgn := CreateRectRgn(0, 0, Width, Height);
  CombineRgn( FullRgn, FullRgn, FullRgn, RGN_COPY );
  SetWindowRgn(Handle, FullRgn, TRUE);
  timer2.Enabled := false;
  FormShow(sender); exit;
 end;
 width  := width  + ((WiHiDef.x-width)  div 15);
 height := height + ((WiHiDef.y-height) div 15);
 Top    := Top  - ((Top -LeftTopDef.Y) div 15);
 Left   := Left - ((Left-LeftTopDef.X) div 15);

 FullRgn := CreateRectRgn(0, 0, Width, Height);
 FullDasRgn := CreateRectRgn(1, 1, Width-1, Height-1);
 CombineRgn( FullRgn, FullRgn, FullDasRgn, RGN_DIFF );
 SetWindowRgn(Handle, FullRgn, TRUE);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 if buka then
 begin
  showWindow(Application.handle,sw_hide);
  buka := false;
  timer2.Enabled := true; exit;
 end;
 if tutup then
 begin
  showWindow(Application.handle,sw_hide);
  exit;
 end;
 showWindow(Application.handle,sw_shownormal);  // make show icon on taskbar
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 DeleteObject(FullRgn);      // Just free Object
 DeleteObject(FullDasRgn);   //
end;

end.
